#ifndef PARAMETER_H
#define PARAMETER_H

#include <string>

#include "ros/ros.h"

class Parameter
{
public:
  Parameter(ros::NodeHandle private_nh,
		    const std::string& caller_name = "",
		    bool verbose_ = true);
  ~Parameter();
  void setVerbose(bool value);
  bool getVerbose();

  template<typename T> 
  int get(const std::string& parameter_name,
          T& variable_to_store,
          T default_value);
private:
  ros::NodeHandle privateNh;
  std::string callerName;	
  bool verbose;	
public: 
  template<typename T>  
  static int get(ros::NodeHandle privateNh, const std::string& parameter_name,
          T& variable_to_store,
          T default_value,
          bool verbose_ = false);
};

#endif //PARAMETER_H